<?php

namespace Drupal\miniorange_saml;

/**
 * @file
 * This class represents support information for customer.
 */

class MiniorangeSamlSupport
{

    public $email;
    public $phone;
    public $query;
    public $query_type;

    /**
     * Constructor.
     */
    public function __construct($email, $phone, $query, $query_type)
    {
        $this->email      = $email;
        $this->phone      = $phone;
        $this->query      = $query;
        $this->query_type = $query_type;

    }

    /**
     * Send support query.
     */
    public function sendSupportQuery() {
        $modules_info = system_get_info('module', 'miniorange_saml');
        $modules_version = $modules_info['version'];

        if( $this->query_type === 'Demo Request' ){
            $this->query = 'Demo request for ' . $this->phone . ' .<br> '. $this->query;
        }

        $this->query = '[Drupal-8 SAML SP ' . $this->query_type . ' | ' .$modules_version. '] ' . $this->query;

        $fields = array (
            'company' => $_SERVER['SERVER_NAME'],
            'email'   => $this->email,
            'phone'   => $this->query_type != 'Demo Request' ? $this->phone : '',
            'ccEmail' => 'drupalsupport@xecurify.com',
            'query'   => $this->query
        );
        $field_string = json_encode( $fields );
        $url = MiniorangeSAMLConstants::BASE_URL . '/moas/rest/customer/contact-us';
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        curl_setopt($ch, CURLOPT_ENCODING, "");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array (
            'Content-Type: application/json',
            'charset: UTF-8',
            'Authorization: Basic'
        ));
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
        $content = curl_exec( $ch );
        if ( curl_errno($ch ) ) {
            \Drupal::logger('miniorange_saml')->error("cURL Error at <strong>sendSupportQuery</strong> function of <strong>MiniorangeSamlSupport.php</strong> file: " . curl_error( $ch ));
            return FALSE;
        }
        curl_close($ch);
        return TRUE;
    }
}
